'------------------------------------------------------------------------------------------------------------------------
'Mikrocontroller 1
'------------------------------------------------------------------------------------------------------------------------
'Grundinitialisierung
$crystal = 14745600                                         'Quarz einstellen
$regfile = "m16def.dat"                                     'Einbinden des Definitionsfiles fr den Atmega16
$baud = 115200                                              'Einstellen der Baudrate fr den Hardware UART

$hwstack = 32
$swstack = 16
$framesize = 40

'------------------------------------------------------------------------------------------------------------------------
'Configuration der angeschlossenen Hardware
'LCD Einstellungen und Initialisierung
Config Lcd = 20 * 4   'LCD Gre Festlegen
Config Lcdpin = Pin , Db4 = Porta.4 , Db5 = Porta.3 , Db6 = Porta.1 , Db7 = Porta.0 , E = Porta.5 , Rs = Porta.6

'Konfigurieren des Analog Digitalwandlers
Config Adc = Single , Prescaler = Auto
Start Adc  'Starten des Analog/Digitalwandlers

'Konfigurieren der Digitaleingnge
Ddrb = &B00000000   'If you are not using PB3, PB4, PB5, PB6 amd PB7, then do not set them as output.
PORTB = &B00000111  'Enable internal pull-up resistors on inputs PB0, PB1 and PB2.

'------------------------------------------------------------------------------------------------------------------------
'Deklaration des Subrutinen
'------------------------------------------------------------------------------------------------------------------------
Declare Sub Datentransfer()

' ------------------------------------------------------------------------------------------------------------------------
'Programmweite Variablen
'Variablen fr die Analogen und Digitalen Zustnde
Dim A1 As Word
Dim A2 As Word
Dim D1 As Bit
Dim D2 As Bit
Dim D3 As Bit
Dim Income As Byte
'------------------------------------------------------------------------------------------------------------------------

Cls       'Display leeren
Cursor Off Noblink

' No need you are already there ' Upperline 'Erste Displayzeile
Lcd "LCD Aktiv"

Waitms 1000

Lowerline 'Zweite Displayzeile
Lcd "Initialisiere Com"

Waitms 1000

Thirdline
Lcd "Comport geoeffnet"

Print "Hello from USART0!"

Cls
Upperline
Lcd "Analogwandler 1:"
Thirdline
Lcd "Digitalwerte:"


' Main loop ============================

Do

      A1 = Getadc(2)                                        'Auslesen des Wertes von ADC.2
      A2 = 1
      D1 = Pinb.0                                           'Auslesen des Wertes von B.0
      D2 = Pinb.1                                           'Auslesen des Wertes von B.1
      D3 = Pinb.2                                           'Auslesen des Wertes von B.2


      Lowerline
      Lcd "                  "
      Locate 2 , 1
      Lcd A1
      Locate 2 , 7
      Lcd A2

      Fourthline
      Lcd "               "

      Locate 4 , 1
      Lcd D1

      Locate 4 , 4
      Lcd D2

      Locate 4 , 7
      Lcd D3

      Income = Inkey()

      If Income = "#" Then

         Call Datentransfer()

      End If

      Waitms 100

Loop

'============================

End


Sub Datentransfer()

   Print  "<;" ; A1 ; ";" ; A2 ; ";" ; D1 ; ";" ; D2 ; ";" ; D3 ; ";>"

End Sub

